from emod_api import schema_to_class as s2c
from emod_api import campaign as camp
from emod_api.interventions import utils

def seed(camp, timestep, coverage=0.01, node_ids=None ):
    """
        This simple function provides a very common piece of functionality to seed an infection. 
    """
    schema_path = camp.schema_path 
    event = s2c.get_class_with_defaults( "CampaignEvent", schema_path )
    coordinator = s2c.get_class_with_defaults( "StandardEventCoordinator", schema_path )
    if coordinator is None:
        print( "s2c.get_class_with_defaults returned None. Maybe no schema.json was provided." )
        return ""
    coordinator.Demographic_Coverage = coverage 
    event.Event_Coordinator_Config = coordinator
    intervention = s2c.get_class_with_defaults( "OutbreakIndividual", schema_path )
    coordinator.Intervention_Config = intervention
    event.Start_Day = float(timestep)
    if node_ids is not None:
        event.Nodeset_Config = utils.do_nodes( schema_path, node_ids )

    return event


